Index: issm/trunk-jpl/src/py/model/solvers/asmoptions.py
===================================================================
--- issm/trunk-jpl/src/py/model/solvers/asmoptions.py	(revision 12929)
+++ 	(revision )
@@ -1,31 +1,0 @@
-#module imports {{{
-from pairoptions import *
-from petscversion  import *
-#}}}
-def asmoptions(*args):
-	#ASMOPTIONS - return ASM petsc options
-	#
-	#   Usage:
-	#      options=asmoptions;
-	
-	#retrieve options provided in varargin
-	arguments=pairoptions(*args) 
-	
-	options=[['mat_type','aij'],['ksp_type','gmres'],['pc_type','asm'],['sub_pc_type','lu'],['pc_asm_overlap',3],['ksp_max_it',100],['ksp_rtol',1e-30]];
-
-	#now, go through our arguments, and write over default options.
-	for i in range(len(arguments.list)):
-		arg1=arguments.list[i][0]
-		arg2=arguments.list[i][1]
-		found=0;
-		for j in range(len(options)):
-			joption=options[j][0]
-			if joption==arg1:
-				joption[1]=arg2;
-				options[j]=joption;
-				found=1;
-				break
-		if not found:
-			#this option did not exist, add it: 
-			options.append([arg1,arg2])
-	return options
Index: issm/trunk-jpl/src/py/model/solvers/iluasmoptions.py
===================================================================
--- issm/trunk-jpl/src/py/model/solvers/iluasmoptions.py	(revision 12929)
+++ 	(revision )
@@ -1,31 +1,0 @@
-#module imports {{{
-from pairoptions import *
-from petscversion  import *
-#}}}
-def iluasmoptions(*args):
-	#ILUASMOPTIONS - return MUMPS direct solver  petsc options
-	#
-	#   Usage:
-	#      options=iluasmoptions;
-	
-	#retrieve options provided in varargin
-	arguments=pairoptions(*args) 
-	
-	options=[['mat_type','aij'],['ksp_type','gmres'],['pc_type','asm'],['sub_pc_type','ilu'],['pc_asm_overlap',5],['ksp_max_it',100],['ksp_rtol',1e-15]];
-
-	#now, go through our arguments, and write over default options.
-	for i in range(len(arguments.list)):
-		arg1=arguments.list[i][0]
-		arg2=arguments.list[i][1]
-		found=0;
-		for j in range(len(options)):
-			joption=options[j][0]
-			if joption==arg1:
-				joption[1]=arg2;
-				options[j]=joption;
-				found=1;
-				break
-		if not found:
-			#this option did not exist, add it: 
-			options.append([arg1,arg2])
-	return options
Index: issm/trunk-jpl/src/py/model/solvers/jacobiasmoptions.py
===================================================================
--- issm/trunk-jpl/src/py/model/solvers/jacobiasmoptions.py	(revision 12929)
+++ 	(revision )
@@ -1,31 +1,0 @@
-#module imports {{{
-from pairoptions import *
-from petscversion  import *
-#}}}
-def jacobiasmoptions(*args):
-	#ASMOPTIONS - return Additive Shwartz Method with Jacobi preconditioner petsc options
-	#
-	#   Usage:
-	#      options=jacobiasmoptions;
-	
-	#retrieve options provided in varargin
-	arguments=pairoptions(*args) 
-	
-	options=[['mat_type','aij'],['ksp_type','gmres'],['pc_type','asm'],['sub_pc_type','jacobi'],['pc_asm_overlap',3],['ksp_max_it',100],['ksp_rtol',1e-15]];
-
-	#now, go through our arguments, and write over default options.
-	for i in range(len(arguments.list)):
-		arg1=arguments.list[i][0]
-		arg2=arguments.list[i][1]
-		found=0;
-		for j in range(len(options)):
-			joption=options[j][0]
-			if joption==arg1:
-				joption[1]=arg2;
-				options[j]=joption;
-				found=1;
-				break
-		if not found:
-			#this option did not exist, add it: 
-			options.append([arg1,arg2])
-	return options
Index: issm/trunk-jpl/src/py/model/solvers/jacobicgoptions.py
===================================================================
--- issm/trunk-jpl/src/py/model/solvers/jacobicgoptions.py	(revision 12929)
+++ 	(revision )
@@ -1,31 +1,0 @@
-#module imports {{{
-from pairoptions import *
-from petscversion  import *
-#}}}
-def jacobicgoptions(*args):
-	#ASMOPTIONS - return Additive Shwartz Method with Jacobi preconditioner petsc options
-	#
-	#   Usage:
-	#      options=jacobicgoptions;
-	
-	#retrieve options provided in varargin
-	arguments=pairoptions(*args) 
-	
-	options=[['mat_type','aij'],['ksp_type','cg'],['ksp_max_it',100],['ksp_rtol',1e-15]];
-
-	#now, go through our arguments, and write over default options.
-	for i in range(len(arguments.list)):
-		arg1=arguments.list[i][0]
-		arg2=arguments.list[i][1]
-		found=0;
-		for j in range(len(options)):
-			joption=options[j][0]
-			if joption==arg1:
-				joption[1]=arg2;
-				options[j]=joption;
-				found=1;
-				break
-		if not found:
-			#this option did not exist, add it: 
-			options.append([arg1,arg2])
-	return options
Index: issm/trunk-jpl/src/py/model/solvers/matlaboptions.py
===================================================================
--- issm/trunk-jpl/src/py/model/solvers/matlaboptions.py	(revision 12929)
+++ 	(revision )
@@ -1,31 +1,0 @@
-#module imports {{{
-from pairoptions import *
-from petscversion  import *
-#}}}
-def matlaboptions(*args):
-	#MATLABOPTIONS - return Matlab petsc options
-	#
-	#   Usage:
-	#      options=matlaboptions;
-	
-	#retrieve options provided in varargin
-	arguments=pairoptions(*args) 
-	
-	options=[['ksp_type','matlab']];
-
-	#now, go through our arguments, and write over default options.
-	for i in range(len(arguments.list)):
-		arg1=arguments.list[i][0]
-		arg2=arguments.list[i][1]
-		found=0;
-		for j in range(len(options)):
-			joption=options[j][0]
-			if joption==arg1:
-				joption[1]=arg2;
-				options[j]=joption;
-				found=1;
-				break
-		if not found:
-			#this option did not exist, add it: 
-			options.append([arg1,arg2])
-	return options
Index: issm/trunk-jpl/src/py/model/solvers/mumpsoptions.py
===================================================================
--- issm/trunk-jpl/src/py/model/solvers/mumpsoptions.py	(revision 12929)
+++ 	(revision )
@@ -1,38 +1,0 @@
-#module imports {{{
-from pairoptions import *
-from petscversion  import *
-#}}}
-def mumpsoptions(*args):
-	#MUMPSOPTIONS - return MUMPS direct solver  petsc options
-	#
-	#   Usage:
-	#      options=mumpsoptions;
-	
-	#retrieve options provided in varargin
-	arguments=pairoptions(*args) 
-
-
-	#default mumps options
-	PETSC_VERSION=petscversion()
-
-	if PETSC_VERSION==2:
-		options=[['mat_type','aijmumps'],['ksp_type','preonly'],['pc_type','lu'],['mat_mumps_icntl_14',120],['pc_factor_shift_positive_definite','true']]
-	if PETSC_VERSION==3:
-		options=[['mat_type','mpiaij'],['ksp_type','preonly'],['pc_type','lu'],['pc_factor_mat_solver_package','mumps'],['mat_mumps_icntl_14',120],['pc_factor_shift_positive_definite','true']]
-
-	#now, go through our arguments, and write over default options.
-	for i in range(len(arguments.list)):
-		arg1=arguments.list[i][0]
-		arg2=arguments.list[i][1]
-		found=0;
-		for j in range(len(options)):
-			joption=options[j][0]
-			if joption==arg1:
-				joption[1]=arg2;
-				options[j]=joption;
-				found=1;
-				break
-		if not found:
-			#this option did not exist, add it: 
-			options.append([arg1,arg2])
-	return options
Index: issm/trunk-jpl/src/py/model/solvers/soroptions.py
===================================================================
--- issm/trunk-jpl/src/py/model/solvers/soroptions.py	(revision 12929)
+++ 	(revision )
@@ -1,31 +1,0 @@
-#module imports {{{
-from pairoptions import *
-from petscversion  import *
-#}}}
-def soroptions(*args):
-	#SOROPTIONS - return Relaxation Solver petsc options
-	#
-	#   Usage:
-	#      options=soroptions;
-	
-	#retrieve options provided in varargin
-	arguments=pairoptions(*args) 
-	
-	options=[['mat_type','aij'],['ksp_type','cg'],['pc_type','sor'],['pc_sor_omega',1.1],['pc_sor_its',2]];
-
-	#now, go through our arguments, and write over default options.
-	for i in range(len(arguments.list)):
-		arg1=arguments.list[i][0]
-		arg2=arguments.list[i][1]
-		found=0;
-		for j in range(len(options)):
-			joption=options[j][0]
-			if joption==arg1:
-				joption[1]=arg2;
-				options[j]=joption;
-				found=1;
-				break
-		if not found:
-			#this option did not exist, add it: 
-			options.append([arg1,arg2])
-	return options
Index: issm/trunk-jpl/src/py/model/solvers/stokesoptions.py
===================================================================
--- issm/trunk-jpl/src/py/model/solvers/stokesoptions.py	(revision 12929)
+++ 	(revision )
@@ -1,40 +1,0 @@
-#module imports {{{
-from pairoptions import *
-from petscversion  import *
-#}}}
-def stokesoptions(*args):
-	#STOKESOPTIONS - return STOKES multi-physics solver petsc options
-	#
-	#   Usage:
-	#      options=stokesoptions;
-	
-	#retrieve options provided in varargin
-	arguments=pairoptions(*args) 
-
-
-	#default stokes options
-	PETSC_VERSION=petscversion()
-
-	if PETSC_VERSION==2:
-		raise RuntimeError('stokesoptions error message: multi-physics options not supported in Petsc 2')
-	if PETSC_VERSION==3:
-		options=[['mat_type','mpiaij'],['ksp_max_it',1000],['ksp_type','gmres'],['pc_type','fieldsplit'],['pc_field_split_type','schur'],\
-	['fieldsplit_0_pc_type','hypre'],['fieldsplit_0_ksp_type','gmres'],['fieldsplit_0_pc_hypre_type','boomerang'],\
-	['fieldsplit_1_pc_type','jacobi'],['fieldsplit_1_ksp_type','preonly'],['issm_option_solver','stokes']]
-
-	#now, go through our arguments, and write over default options.
-	for i in range(len(arguments.list)):
-		arg1=arguments.list[i][0]
-		arg2=arguments.list[i][1]
-		found=0;
-		for j in range(len(options)):
-			joption=options[j][0]
-			if joption==arg1:
-				joption[1]=arg2;
-				options[j]=joption;
-				found=1;
-				break
-		if not found:
-			#this option did not exist, add it: 
-			options.append([arg1,arg2])
-	return options