Index: issm/trunk-jpl/src/m/boundaryconditions/SetIceSheetBC.m
===================================================================
--- issm/trunk-jpl/src/m/boundaryconditions/SetIceSheetBC.m	(revision 13071)
+++ issm/trunk-jpl/src/m/boundaryconditions/SetIceSheetBC.m	(revision 13076)
@@ -34,9 +34,9 @@
 
 %Create zeros basal melting rate and surface mass balance if not specified
-if (isnan(md.surfaceforcings.precipitation) & (md.surfaceforcings.ispdd==1) & (md.surfaceforcings.ispdd==0)),
+if (isnan(md.surfaceforcings.precipitation) & (md.surfaceforcings.ispdd==1)),
 	md.surfaceforcings.precipitation=zeros(md.mesh.numberofvertices,1);
 	disp('      no surfaceforcings.precipitation specified: values set as zero');
 end
-if isnan(md.surfaceforcings.mass_balance) & (md.surfaceforcings.ispdd==0),
+if (isnan(md.surfaceforcings.mass_balance) & (md.surfaceforcings.ispdd==0)),
 	md.surfaceforcings.mass_balance=zeros(md.mesh.numberofvertices,1);
 	disp('      no surfaceforcings.mass_balance specified: values set as zero');
Index: issm/trunk-jpl/src/m/boundaryconditions/SetIceShelfBC.m
===================================================================
--- issm/trunk-jpl/src/m/boundaryconditions/SetIceShelfBC.m	(revision 13071)
+++ issm/trunk-jpl/src/m/boundaryconditions/SetIceShelfBC.m	(revision 13076)
@@ -65,9 +65,9 @@
 
 %Create zeros basalforcings and surfaceforcings
-if (isnan(md.surfaceforcings.precipitation) & (md.surfaceforcings.ispdd==1) & (md.surfaceforcings.ispdd==0)),
+if (isnan(md.surfaceforcings.precipitation) & (md.surfaceforcings.ispdd==1)),
 	md.surfaceforcings.precipitation=zeros(md.mesh.numberofvertices,1);
 	disp('      no surfaceforcings.precipitation specified: values set as zero');
 end
-if isnan(md.surfaceforcings.mass_balance) & (md.surfaceforcings.ispdd==0),
+if (isnan(md.surfaceforcings.mass_balance) & (md.surfaceforcings.ispdd==0)),
 	        md.surfaceforcings.mass_balance=zeros(md.mesh.numberofvertices,1);
 		disp('      no surfaceforcings.mass_balance specified: values set as zero');
Index: issm/trunk-jpl/src/m/boundaryconditions/SetIceShelfBC.py
===================================================================
--- issm/trunk-jpl/src/m/boundaryconditions/SetIceShelfBC.py	(revision 13071)
+++ issm/trunk-jpl/src/m/boundaryconditions/SetIceShelfBC.py	(revision 13076)
@@ -69,8 +69,8 @@
 
 	#Create zeros basalforcings and surfaceforcings
-	if numpy.all(numpy.isnan(md.surfaceforcings.precipitation)):
+	if numpy.all(numpy.isnan(md.surfaceforcings.precipitation)) and (md.surfaceforcings.ispdd==1):
 		md.surfaceforcings.precipitation=numpy.zeros(md.mesh.numberofvertices)
 		print '      no surfaceforcings.precipitation specified: values set as zero'
-	if numpy.all(numpy.isnan(md.surfaceforcings.mass_balance)):
+	if numpy.all(numpy.isnan(md.surfaceforcings.mass_balance)) and (md.surfaceforcings.ispdd==0):
 		md.surfaceforcings.mass_balance=numpy.zeros(md.mesh.numberofvertices)
 		print '      no surfaceforcings.mass_balance specified: values set as zero'
Index: issm/trunk-jpl/src/m/boundaryconditions/SetMarineIceSheetBC.m
===================================================================
--- issm/trunk-jpl/src/m/boundaryconditions/SetMarineIceSheetBC.m	(revision 13071)
+++ issm/trunk-jpl/src/m/boundaryconditions/SetMarineIceSheetBC.m	(revision 13076)
@@ -76,9 +76,9 @@
 
 %Create zeros basalforcings and surfaceforcings
-if (isnan(md.surfaceforcings.precipitation)& (md.surfaceforcings.ispdd==1) & (md.surfaceforcings.ispdd==0)),
+if (isnan(md.surfaceforcings.precipitation) & (md.surfaceforcings.ispdd==1)),
 	md.surfaceforcings.precipitation=zeros(md.mesh.numberofvertices,1);
 	disp('      no surfaceforcings.precipitation specified: values set as zero');
 end
-if isnan(md.surfaceforcings.mass_balance) & (md.surfaceforcings.ispdd==0),
+if (isnan(md.surfaceforcings.mass_balance) & (md.surfaceforcings.ispdd==0)),
 	md.surfaceforcings.mass_balance=zeros(md.mesh.numberofvertices,1);
 	disp('      no surfaceforcings.mass_balance specified: values set as zero');