Index: issm/trunk-jpl/src/modules/matlab/Makefile.am
===================================================================
--- issm/trunk-jpl/src/modules/matlab/Makefile.am	(revision 13072)
+++ issm/trunk-jpl/src/modules/matlab/Makefile.am	(revision 13086)
@@ -5,39 +5,39 @@
 #Modules {{{1
 if MODULES
-lib_LTLIBRARIES =  AverageFilter.la\
-			       BamgMesher.la\
-				   BamgConvertMesh.la\
-				   BamgTriangulate.la\
-				   ContourToMesh.la\
-				   ContourToNodes.la\
-				   ElementConnectivity.la\
-				   EnumToString.la\
-				   Exp2Kml.la\
-				   HoleFiller.la\
-				   InternalFront.la\
-				   InterpFromGridToMesh.la\
-				   InterpFromMeshToMesh2d.la\
-				   InterpFromMeshToMesh3d.la\
-				   InterpFromMeshToGrid.la\
-				   InterpFromMesh2d.la\
-				   KMLFileRead.la\
-				   KMLMeshWrite.la\
-				   KMLOverlay.la\
-				   Kml2Exp.la\
-				   Kriging.la\
-				   Ll2xy.la\
-				   NodeConnectivity.la\
-				   MeshPartition.la\
-				   MeshProfileIntersection.la\
-				   PointCloudFindNeighbors.la\
-				   PropagateFlagsFromConnectivity.la\
-				   Shp2Kml.la\
-				   StringToEnum.la\
-				   TriaSearch.la\
-				   TriMesh.la\
-				   TriMeshProcessRifts.la\
-				   Scotch.la\
-				   Xy2ll.la\
-                   Chaco.la
+lib_LTLIBRARIES =  AverageFilter.la
+#			       BamgMesher.la\
+#				   BamgConvertMesh.la\
+#				   BamgTriangulate.la\
+#				   ContourToMesh.la\
+#				   ContourToNodes.la\
+#				   ElementConnectivity.la\
+#				   EnumToString.la\
+#				   Exp2Kml.la\
+#				   HoleFiller.la\
+#				   InternalFront.la\
+#				   InterpFromGridToMesh.la\
+#				   InterpFromMeshToMesh2d.la\
+#				   InterpFromMeshToMesh3d.la\
+#				   InterpFromMeshToGrid.la\
+#				   InterpFromMesh2d.la\
+#				   KMLFileRead.la\
+#				   KMLMeshWrite.la\
+#				   KMLOverlay.la\
+#				   Kml2Exp.la\
+#				   Kriging.la\
+#				   Ll2xy.la\
+#				   NodeConnectivity.la\
+#				   MeshPartition.la\
+#				   MeshProfileIntersection.la\
+#				   PointCloudFindNeighbors.la\
+#				   PropagateFlagsFromConnectivity.la\
+#				   Shp2Kml.la\
+#				   StringToEnum.la\
+#				   TriaSearch.la\
+#				   TriMesh.la\
+#				   TriMeshProcessRifts.la\
+#				   Scotch.la\
+#				   Xy2ll.la\
+#                  Chaco.la
 endif 
 #}}}
@@ -91,142 +91,144 @@
 
 #Bin sources {{{1
+echo "WHAT IS MUMPS: " $(MUMPSLIB)
+echo "WHAT IS MPI  : " $(MPILIB)
 AverageFilter_la_SOURCES = ../AverageFilter/AverageFilter.cpp\
 			  ../AverageFilter/AverageFilter.h
-AverageFilter_la_LIBADD = ${deps} $(MPILIB) $(PETSCLIB)
-
-BamgMesher_la_SOURCES = ../BamgMesher/BamgMesher.cpp\
-					../BamgMesher/BamgMesher.h
-BamgMesher_la_LIBADD = ${deps} $(MPILIB) $(PETSCLIB)
-
-BamgConvertMesh_la_SOURCES = ../BamgConvertMesh/BamgConvertMesh.cpp\
-					../BamgConvertMesh/BamgConvertMesh.h
-BamgConvertMesh_la_LIBADD = ${deps} $(MPILIB) $(PETSCLIB)
-
-BamgTriangulate_la_SOURCES = ../BamgTriangulate/BamgTriangulate.cpp\
-								  ../BamgTriangulate/BamgTriangulate.h
-BamgTriangulate_la_LIBADD = ${deps} $(MPILIB) $(PETSCLIB)
-
-Chaco_la_SOURCES = ../Chaco/Chaco.cpp\
-					../Chaco/Chaco.h
-Chaco_la_LIBADD = ${deps} $(MPILIB) $(PETSCLIB) $(CHACOLIB)
-
-ContourToMesh_la_SOURCES = ../ContourToMesh/ContourToMesh.cpp\
-			               ../ContourToMesh/ContourToMesh.h
-ContourToMesh_la_LIBADD = ${deps} $(MPILIB) $(PETSCLIB) $(MULTITHREADINGLIB)
-
-ContourToNodes_la_SOURCES = ../ContourToNodes/ContourToNodes.cpp\
-			  ../ContourToNodes/ContourToNodes.h
-ContourToNodes_la_LIBADD = ${deps} $(MPILIB) $(PETSCLIB)
-
-ElementConnectivity_la_SOURCES = ../ElementConnectivity/ElementConnectivity.cpp\
-			  ../ElementConnectivity/ElementConnectivity.h
-ElementConnectivity_la_LIBADD = ${deps} $(MPILIB) $(PETSCLIB)
-
-EnumToString_la_SOURCES = ../EnumToString/EnumToString.cpp\
-			  ../EnumToString/EnumToString.h
-EnumToString_la_LIBADD = ${deps} $(MPILIB) $(PETSCLIB)
-
-StringToEnum_la_SOURCES = ../StringToEnum/StringToEnum.cpp\
-			  ../StringToEnum/StringToEnum.h
-StringToEnum_la_LIBADD = ${deps} $(MPILIB) $(PETSCLIB)
-
-HoleFiller_la_SOURCES = ../HoleFiller/HoleFiller.cpp\
-			  ../HoleFiller/HoleFiller.h
-HoleFiller_la_LIBADD = ${deps} $(MPILIB) $(PETSCLIB) 
-
-InternalFront_la_SOURCES = ../InternalFront/InternalFront.cpp\
-										 ../InternalFront/InternalFront.h
-InternalFront_la_LIBADD = ${deps} $(MPILIB) $(PETSCLIB)
-
-InterpFromGridToMesh_la_SOURCES = ../InterpFromGridToMesh/InterpFromGridToMesh.cpp\
-			  ../InterpFromGridToMesh/InterpFromGridToMesh.h
-InterpFromGridToMesh_la_LIBADD = ${deps} $(MPILIB) $(PETSCLIB) $(MULTITHREADINGLIB)
-
-InterpFromMeshToMesh2d_la_SOURCES = ../InterpFromMeshToMesh2d/InterpFromMeshToMesh2d.cpp\
-							../InterpFromMeshToMesh2d/InterpFromMeshToMesh2d.h
-InterpFromMeshToMesh2d_la_LIBADD = ${deps} $(MPILIB) $(PETSCLIB) $(MULTITHREADINGLIB)
-
-InterpFromMeshToMesh3d_la_SOURCES = ../InterpFromMeshToMesh3d/InterpFromMeshToMesh3d.cpp\
-									../InterpFromMeshToMesh3d/InterpFromMeshToMesh3d.h
-InterpFromMeshToMesh3d_la_LIBADD = ${deps} $(MPILIB) $(PETSCLIB)
-
-InterpFromMeshToGrid_la_SOURCES = ../InterpFromMeshToGrid/InterpFromMeshToGrid.cpp\
-									../InterpFromMeshToGrid/InterpFromMeshToGrid.h
-InterpFromMeshToGrid_la_LIBADD = ${deps} $(MPILIB) $(PETSCLIB)
-
-InterpFromMesh2d_la_SOURCES = ../InterpFromMesh2d/InterpFromMesh2d.cpp\
-									../InterpFromMesh2d/InterpFromMesh2d.h
-InterpFromMesh2d_la_LIBADD = ${deps} $(MPILIB) $(PETSCLIB) $(MULTITHREADINGLIB)
-
-KMLFileRead_la_SOURCES = ../KMLFileRead/KMLFileRead.cpp\
-			  ../KMLFileRead/KMLFileRead.h
-KMLFileRead_la_LIBADD = ${deps} $(MPILIB) $(PETSCLIB)
-
-KMLMeshWrite_la_SOURCES = ../KMLMeshWrite/KMLMeshWrite.cpp\
-			  ../KMLMeshWrite/KMLMeshWrite.h
-KMLMeshWrite_la_LIBADD = ${deps} $(MPILIB) $(PETSCLIB)
-
-KMLOverlay_la_SOURCES = ../KMLOverlay/KMLOverlay.cpp\
-			  ../KMLOverlay/KMLOverlay.h
-KMLOverlay_la_LIBADD = ${deps} $(MPILIB) $(PETSCLIB)
-
-Xy2ll_la_SOURCES = ../Xy2ll/Xy2ll.cpp\
-			  ../Xy2ll/Xy2ll.h
-Xy2ll_la_LIBADD = ${deps} $(MPILIB) $(PETSCLIB)
-
-Ll2xy_la_SOURCES = ../Ll2xy/Ll2xy.cpp\
-			  ../Ll2xy/Ll2xy.h
-Ll2xy_la_LIBADD = ${deps} $(MPILIB) $(PETSCLIB)
-
-Exp2Kml_la_SOURCES = ../Exp2Kml/Exp2Kml.cpp\
-			  ../Exp2Kml/Exp2Kml.h
-Exp2Kml_la_LIBADD = ${deps} $(MPILIB) $(PETSCLIB)
-
-Kml2Exp_la_SOURCES = ../Kml2Exp/Kml2Exp.cpp\
-			  ../Kml2Exp/Kml2Exp.h
-Kml2Exp_la_LIBADD = ${deps} $(MPILIB) $(PETSCLIB)
-
-Kriging_la_SOURCES = ../Kriging/Kriging.cpp\
-						../Kriging/Kriging.h
-Kriging_la_LIBADD = ${deps} $(MPILIB) $(PETSCLIB) $(MULTITHREADINGLIB)
-
-MeshPartition_la_SOURCES = ../MeshPartition/MeshPartition.cpp\
-			  ../MeshPartition/MeshPartition.h
-MeshPartition_la_LIBADD = ${deps} $(MPILIB) $(PETSCLIB)
-
-MeshProfileIntersection_la_SOURCES = ../MeshProfileIntersection/MeshProfileIntersection.cpp\
-			  ../MeshProfileIntersection/MeshProfileIntersection.h
-MeshProfileIntersection_la_LIBADD = ${deps} $(MPILIB) $(PETSCLIB)
-
-NodeConnectivity_la_SOURCES = ../NodeConnectivity/NodeConnectivity.cpp\
-										../NodeConnectivity/NodeConnectivity.h
-NodeConnectivity_la_LIBADD = ${deps} $(MPILIB) $(PETSCLIB)
-
-PointCloudFindNeighbors_la_SOURCES = ../PointCloudFindNeighbors/PointCloudFindNeighbors.cpp\
-			  ../PointCloudFindNeighbors/PointCloudFindNeighbors.h
-PointCloudFindNeighbors_la_LIBADD = ${deps} $(MPILIB) $(PETSCLIB) $(MULTITHREADINGLIB)
-
-PropagateFlagsFromConnectivity_la_SOURCES = ../PropagateFlagsFromConnectivity/PropagateFlagsFromConnectivity.cpp\
-			  ../PropagateFlagsFromConnectivity/PropagateFlagsFromConnectivity.h
-PropagateFlagsFromConnectivity_la_LIBADD = ${deps} $(MPILIB) $(PETSCLIB)
-
-Scotch_la_SOURCES = ../Scotch/Scotch.cpp\
-                    ../Scotch/Scotch.h
-Scotch_la_LIBADD = ${deps} $(SCOTCHLIB)
-
-Shp2Kml_la_SOURCES = ../Shp2Kml/Shp2Kml.cpp\
-                     ../Shp2Kml/Shp2Kml.h
-Shp2Kml_la_LIBADD = ${deps}
-
-TriaSearch_la_SOURCES = ../TriaSearch/TriaSearch.cpp\
-			  ../TriaSearch/TriaSearch.h
-TriaSearch_la_LIBADD = ${deps} $(MPILIB) $(PETSCLIB)
-
-TriMesh_la_SOURCES = ../TriMesh/TriMesh.cpp\
-                     ../TriMesh/TriMesh.h
-TriMesh_la_LIBADD = ${deps} $(MPILIB) $(PETSCLIB) $(TRIANGLELIB)
-
-TriMeshProcessRifts_la_SOURCES = ../TriMeshProcessRifts/TriMeshProcessRifts.cpp\
-			  ../TriMeshProcessRifts/TriMeshProcessRifts.h
-TriMeshProcessRifts_la_LIBADD = ${deps} $(MPILIB) $(PETSCLIB)
+AverageFilter_la_LIBADD = ${deps} $(PETSCLIB) $(MUMPSLIB) $(MPILIB) $(FLIBS) $(FORTRANLIB) $(METISLIB) $(MULTITHREADINGLIB)
+
+#BamgMesher_la_SOURCES = ../BamgMesher/BamgMesher.cpp\
+#					../BamgMesher/BamgMesher.h
+#BamgMesher_la_LIBADD = ${deps} $(MPILIB) $(PETSCLIB)
+
+#BamgConvertMesh_la_SOURCES = ../BamgConvertMesh/BamgConvertMesh.cpp\
+#					../BamgConvertMesh/BamgConvertMesh.h
+#BamgConvertMesh_la_LIBADD = ${deps} $(MPILIB) $(PETSCLIB)
+
+#BamgTriangulate_la_SOURCES = ../BamgTriangulate/BamgTriangulate.cpp\
+#								  ../BamgTriangulate/BamgTriangulate.h
+#BamgTriangulate_la_LIBADD = ${deps} $(MPILIB) $(PETSCLIB)
+
+#Chaco_la_SOURCES = ../Chaco/Chaco.cpp\
+#					../Chaco/Chaco.h
+#Chaco_la_LIBADD = ${deps} $(MPILIB) $(PETSCLIB) $(CHACOLIB)
+
+#ContourToMesh_la_SOURCES = ../ContourToMesh/ContourToMesh.cpp\
+#			               ../ContourToMesh/ContourToMesh.h
+#ContourToMesh_la_LIBADD = ${deps} $(MPILIB) $(PETSCLIB) $(MULTITHREADINGLIB)
+
+#ContourToNodes_la_SOURCES = ../ContourToNodes/ContourToNodes.cpp\
+#			  ../ContourToNodes/ContourToNodes.h
+#ContourToNodes_la_LIBADD = ${deps} $(MPILIB) $(PETSCLIB)
+
+#ElementConnectivity_la_SOURCES = ../ElementConnectivity/ElementConnectivity.cpp\
+#			  ../ElementConnectivity/ElementConnectivity.h
+#ElementConnectivity_la_LIBADD = ${deps} $(MPILIB) $(PETSCLIB)
+
+#EnumToString_la_SOURCES = ../EnumToString/EnumToString.cpp\
+#			  ../EnumToString/EnumToString.h
+#EnumToString_la_LIBADD = ${deps} $(MPILIB) $(PETSCLIB)
+
+#StringToEnum_la_SOURCES = ../StringToEnum/StringToEnum.cpp\
+#			  ../StringToEnum/StringToEnum.h
+#StringToEnum_la_LIBADD = ${deps} $(MPILIB) $(PETSCLIB)
+
+#HoleFiller_la_SOURCES = ../HoleFiller/HoleFiller.cpp\
+#			  ../HoleFiller/HoleFiller.h
+#HoleFiller_la_LIBADD = ${deps} $(MPILIB) $(PETSCLIB) 
+
+#InternalFront_la_SOURCES = ../InternalFront/InternalFront.cpp\
+#										 ../InternalFront/InternalFront.h
+#InternalFront_la_LIBADD = ${deps} $(MPILIB) $(PETSCLIB)
+
+#InterpFromGridToMesh_la_SOURCES = ../InterpFromGridToMesh/InterpFromGridToMesh.cpp\
+#			  ../InterpFromGridToMesh/InterpFromGridToMesh.h
+#InterpFromGridToMesh_la_LIBADD = ${deps} $(MPILIB) $(PETSCLIB) $(MULTITHREADINGLIB)
+
+#InterpFromMeshToMesh2d_la_SOURCES = ../InterpFromMeshToMesh2d/InterpFromMeshToMesh2d.cpp\
+#							../InterpFromMeshToMesh2d/InterpFromMeshToMesh2d.h
+#InterpFromMeshToMesh2d_la_LIBADD = ${deps} $(MPILIB) $(PETSCLIB) $(MULTITHREADINGLIB)
+
+#InterpFromMeshToMesh3d_la_SOURCES = ../InterpFromMeshToMesh3d/InterpFromMeshToMesh3d.cpp\
+#									../InterpFromMeshToMesh3d/InterpFromMeshToMesh3d.h
+#InterpFromMeshToMesh3d_la_LIBADD = ${deps} $(MPILIB) $(PETSCLIB)
+
+#InterpFromMeshToGrid_la_SOURCES = ../InterpFromMeshToGrid/InterpFromMeshToGrid.cpp\
+#									../InterpFromMeshToGrid/InterpFromMeshToGrid.h
+#InterpFromMeshToGrid_la_LIBADD = ${deps} $(MPILIB) $(PETSCLIB)
+
+#InterpFromMesh2d_la_SOURCES = ../InterpFromMesh2d/InterpFromMesh2d.cpp\
+#									../InterpFromMesh2d/InterpFromMesh2d.h
+#InterpFromMesh2d_la_LIBADD = ${deps} $(MPILIB) $(PETSCLIB) $(MULTITHREADINGLIB)
+
+#KMLFileRead_la_SOURCES = ../KMLFileRead/KMLFileRead.cpp\
+#			  ../KMLFileRead/KMLFileRead.h
+#KMLFileRead_la_LIBADD = ${deps} $(MPILIB) $(PETSCLIB)
+
+#KMLMeshWrite_la_SOURCES = ../KMLMeshWrite/KMLMeshWrite.cpp\
+#			  ../KMLMeshWrite/KMLMeshWrite.h
+#KMLMeshWrite_la_LIBADD = ${deps} $(MPILIB) $(PETSCLIB)
+
+#KMLOverlay_la_SOURCES = ../KMLOverlay/KMLOverlay.cpp\
+#			  ../KMLOverlay/KMLOverlay.h
+#KMLOverlay_la_LIBADD = ${deps} $(MPILIB) $(PETSCLIB)
+
+#Xy2ll_la_SOURCES = ../Xy2ll/Xy2ll.cpp\
+#			  ../Xy2ll/Xy2ll.h
+#Xy2ll_la_LIBADD = ${deps} $(MPILIB) $(PETSCLIB)
+
+#Ll2xy_la_SOURCES = ../Ll2xy/Ll2xy.cpp\
+#			  ../Ll2xy/Ll2xy.h
+#Ll2xy_la_LIBADD = ${deps} $(MPILIB) $(PETSCLIB)
+
+#Exp2Kml_la_SOURCES = ../Exp2Kml/Exp2Kml.cpp\
+#			  ../Exp2Kml/Exp2Kml.h
+#Exp2Kml_la_LIBADD = ${deps} $(MPILIB) $(PETSCLIB)
+
+#Kml2Exp_la_SOURCES = ../Kml2Exp/Kml2Exp.cpp\
+#			  ../Kml2Exp/Kml2Exp.h
+#Kml2Exp_la_LIBADD = ${deps} $(MPILIB) $(PETSCLIB)
+
+#Kriging_la_SOURCES = ../Kriging/Kriging.cpp\
+#						../Kriging/Kriging.h
+#Kriging_la_LIBADD = ${deps} $(MPILIB) $(PETSCLIB) $(MULTITHREADINGLIB)
+
+#MeshPartition_la_SOURCES = ../MeshPartition/MeshPartition.cpp\
+#			  ../MeshPartition/MeshPartition.h
+#MeshPartition_la_LIBADD = ${deps} $(MPILIB) $(PETSCLIB)
+
+#MeshProfileIntersection_la_SOURCES = ../MeshProfileIntersection/MeshProfileIntersection.cpp\
+#			  ../MeshProfileIntersection/MeshProfileIntersection.h
+#MeshProfileIntersection_la_LIBADD = ${deps} $(MPILIB) $(PETSCLIB)
+
+#NodeConnectivity_la_SOURCES = ../NodeConnectivity/NodeConnectivity.cpp\
+#										../NodeConnectivity/NodeConnectivity.h
+#NodeConnectivity_la_LIBADD = ${deps} $(MPILIB) $(PETSCLIB)
+
+#PointCloudFindNeighbors_la_SOURCES = ../PointCloudFindNeighbors/PointCloudFindNeighbors.cpp\
+#			  ../PointCloudFindNeighbors/PointCloudFindNeighbors.h
+#PointCloudFindNeighbors_la_LIBADD = ${deps} $(MPILIB) $(PETSCLIB) $(MULTITHREADINGLIB)
+
+#PropagateFlagsFromConnectivity_la_SOURCES = ../PropagateFlagsFromConnectivity/PropagateFlagsFromConnectivity.cpp\
+#			  ../PropagateFlagsFromConnectivity/PropagateFlagsFromConnectivity.h
+#PropagateFlagsFromConnectivity_la_LIBADD = ${deps} $(MPILIB) $(PETSCLIB)
+
+#Scotch_la_SOURCES = ../Scotch/Scotch.cpp\
+#                    ../Scotch/Scotch.h
+#Scotch_la_LIBADD = ${deps} $(SCOTCHLIB)
+
+#Shp2Kml_la_SOURCES = ../Shp2Kml/Shp2Kml.cpp\
+#                     ../Shp2Kml/Shp2Kml.h
+#Shp2Kml_la_LIBADD = ${deps}
+
+#TriaSearch_la_SOURCES = ../TriaSearch/TriaSearch.cpp\
+#			  ../TriaSearch/TriaSearch.h
+#TriaSearch_la_LIBADD = ${deps} $(MPILIB) $(PETSCLIB)
+
+#TriMesh_la_SOURCES = ../TriMesh/TriMesh.cpp\
+#                     ../TriMesh/TriMesh.h
+#TriMesh_la_LIBADD = ${deps} $(MPILIB) $(PETSCLIB) $(TRIANGLELIB)
+
+#TriMeshProcessRifts_la_SOURCES = ../TriMeshProcessRifts/TriMeshProcessRifts.cpp\
+#			  ../TriMeshProcessRifts/TriMeshProcessRifts.h
+#TriMeshProcessRifts_la_LIBADD = ${deps} $(MPILIB) $(PETSCLIB)
 #}}}