Index: issm/trunk-jpl/scripts/report.sh
===================================================================
--- issm/trunk-jpl/scripts/report.sh	(revision 13203)
+++ issm/trunk-jpl/scripts/report.sh	(revision 13210)
@@ -78,5 +78,5 @@
 	cat << END >> report.html
 	<table $(echo $BODY_STYLE) style="border-collapse:collapse;">
-	<tr><td $BODY_FONT>status: <span style=\"color:#ff0000\">Installation failed<\/span></td></tr>
+	<tr><td $BODY_FONTC>status: <span style=\"color:#ff0000\">Installation failed<\/span></td></tr>
 	</table>
 	<table $FOOTER_STYLE><tr><td $FOOTER_FONT><a href="http://issm.jpl.nasa.gov" title="ISSM website" target="_blank">ISSM</a> nightly run report</td></tr></table>
@@ -103,12 +103,12 @@
 <table $(echo $BODY_STYLE) style="border-collapse:collapse;">
 $(if [ $CRASH_MATLAB -eq 0 ]; then
-echo "<tr><td $BODY_FONT>status: <span style=\"color:#008000\">all test desks have been run</span></td></tr>"
+echo "<tr><td $BODY_FONTL>status: <span style=\"color:#008000\">all test desks have been run</span></td></tr>"
 else
-	echo "<tr><td $BODY_FONT>status: <span style=\"color:#ff0000\">Matlab crashed</span></td></tr>"
+	echo "<tr><td $BODY_FONTL>status: <span style=\"color:#ff0000\">Matlab crashed</span></td></tr>"
 fi)
-<tr><td $BODY_FONT>Total execution time: $EL_MATLAB</td></tr>
-<tr><td $BODY_FONT>Number of successes: $NUM_MATLAB_SUC/$NUM_MATLAB_TOT</td></tr>
-<tr><td $BODY_FONT>Number of errors: $NUM_MATLAB_ERR/$NUM_MATLAB_TOT</td></tr>
-<tr><td $BODY_FONT>Number of failures: $NUM_MATLAB_FAI/$NUM_MATLAB_TOT</td></tr>
+<tr><td $BODY_FONTL>Total execution time: $EL_MATLAB</td></tr>
+<tr><td $BODY_FONTL>Number of successes: $NUM_MATLAB_SUC/$NUM_MATLAB_TOT</td></tr>
+<tr><td $BODY_FONTL>Number of errors: $NUM_MATLAB_ERR/$NUM_MATLAB_TOT</td></tr>
+<tr><td $BODY_FONTL>Number of failures: $NUM_MATLAB_FAI/$NUM_MATLAB_TOT</td></tr>
 </table>
 END
@@ -132,12 +132,12 @@
 <table $(echo $BODY_STYLE) style="border-collapse:collapse;">
 $(if [ $CRASH_PYTHON -eq 0 ]; then
-	echo "<tr><td $BODY_FONT>status: <span style=\"color:#008000\">all test desks have been run</span></td></tr>"
+	echo "<tr><td $BODY_FONTL>status: <span style=\"color:#008000\">all test desks have been run</span></td></tr>"
 else
-	echo "<tr><td $BODY_FONT>status: <span style=\"color:#ff0000\">Python crashed</span></td></tr>"
+	echo "<tr><td $BODY_FONTL>status: <span style=\"color:#ff0000\">Python crashed</span></td></tr>"
 fi)
-<tr><td $BODY_FONT>Total execution time: $EL_PYTHON</td></tr>
-<tr><td $BODY_FONT>Number of successes: $NUM_PYTHON_SUC/$NUM_PYTHON_TOT</td></tr>
-<tr><td $BODY_FONT>Number of errors: $NUM_PYTHON_ERR/$NUM_PYTHON_TOT</td></tr>
-<tr><td $BODY_FONT>Number of failures: $NUM_PYTHON_FAI/$NUM_PYTHON_TOT</td></tr>
+<tr><td $BODY_FONTL>Total execution time: $EL_PYTHON</td></tr>
+<tr><td $BODY_FONTL>Number of successes: $NUM_PYTHON_SUC/$NUM_PYTHON_TOT</td></tr>
+<tr><td $BODY_FONTL>Number of errors: $NUM_PYTHON_ERR/$NUM_PYTHON_TOT</td></tr>
+<tr><td $BODY_FONTL>Number of failures: $NUM_PYTHON_FAI/$NUM_PYTHON_TOT</td></tr>
 </table>
 END
@@ -152,24 +152,20 @@
 then
 	cat << END >> report.html
-<table $(echo $H2_STYLE)><tr><td $(echo $H2_FONT)>List of Matlab tests</td></tr></table>
-<table $(echo $BODY_STYLE) style="border-collapse:collapse;">
+<table $H2_STYLE><tr><td $(echo $H2_FONT)>List of Matlab tests</td></tr></table>
+<table $BODY_STYLE style="border-collapse:collapse;">
 <tr> 
-<th $(echo $BODY_FONT)>Result</th> 
-<th $(echo $BODY_FONT)>Tolerance</th> 
-<th $(echo $BODY_FONT)>Test id</th>  
-<th $(echo $BODY_FONT)>Test name</th> 
-<th $(echo $BODY_FONT)>Field checked</th>
+<th $BODY_FONT>Result</th> 
+<th $BODY_FONT>Tolerance</th> 
+<th $BODY_FONT>Test id</th>  
+<th $BODY_FONT>Test name</th> 
+<th $BODY_FONT>Field checked</th>
 </tr>
 $(cat matlab_short.log | while read line
   do
 	  echo "<tr>"
-
-	  #get status
 	  STATUS=`echo $line | awk '{print $1}'`
-
 	  #FAILURE
 	  if [ "$STATUS" = "FAILURE" ]
 	  then
-
 		  FONTC=$(echo "$BODY_FONTC bgcolor=#ffff00");
 		  FONTL=$(echo "$BODY_FONTL bgcolor=#ffff00");
@@ -177,7 +173,5 @@
 		  { printf("<td %s id=FAILURE>%s</td>\n<td %s>%s</td>\n<td %s>%s</td>\n<td %s>%s</td>\n<td %s>%s</td>\n\n",FONTL,$1,FONTC,$3,FONTC,$6,FONTL,$9,FONTL,$11);}
 		  '; 
-
 	  else
-
 		  #SUCCESS
 		  if [ "$STATUS" = "SUCCESS" ]
@@ -214,9 +208,9 @@
 	<table $(echo $BODY_STYLE) style="border-collapse:collapse;">
 	<tr> 
-	<th $(echo $BODY_FONT)>Result</th> 
-	<th $(echo $BODY_FONT)>Tolerance</th> 
-	<th $(echo $BODY_FONT)>Test id</th>  
-	<th $(echo $BODY_FONT)>Test name</th> 
-	<th $(echo $BODY_FONT)>Field checked</th>
+	<th $BODY_FONT>Result</th> 
+	<th $BODY_FONT>Tolerance</th> 
+	<th $BODY_FONT>Test id</th>  
+	<th $BODY_FONT>Test name</th> 
+	<th $BODY_FONT>Field checked</th>
 	</tr>
 	$(cat matlab_short.log | while read line