Index: issm/trunk-jpl/src/m/enum/EnumDefinitions.py
===================================================================
--- issm/trunk-jpl/src/m/enum/EnumDefinitions.py	(revision 13349)
+++ issm/trunk-jpl/src/m/enum/EnumDefinitions.py	(revision 13427)
@@ -19,14 +19,4 @@
 	return StringToEnum('AutodiffIsautodiff')[0]
 
-def AutodiffDependentsEnum():
-	"""
-	AUTODIFFDEPENDENTSENUM - Enum of AutodiffDependents
-
-	   Usage:
-	      macro=AutodiffDependentsEnum()
-	"""
-
-	return StringToEnum('AutodiffDependents')[0]
-
 def AutodiffNumDependentsEnum():
 	"""
@@ -39,13 +29,43 @@
 	return StringToEnum('AutodiffNumDependents')[0]
 
-def AutodiffIndependentsEnum():
-	"""
-	AUTODIFFINDEPENDENTSENUM - Enum of AutodiffIndependents
-
-	   Usage:
-	      macro=AutodiffIndependentsEnum()
-	"""
-
-	return StringToEnum('AutodiffIndependents')[0]
+def AutodiffNumDependentObjectsEnum():
+	"""
+	AUTODIFFNUMDEPENDENTOBJECTSENUM - Enum of AutodiffNumDependentObjects
+
+	   Usage:
+	      macro=AutodiffNumDependentObjectsEnum()
+	"""
+
+	return StringToEnum('AutodiffNumDependentObjects')[0]
+
+def AutodiffDependentObjectNamesEnum():
+	"""
+	AUTODIFFDEPENDENTOBJECTNAMESENUM - Enum of AutodiffDependentObjectNames
+
+	   Usage:
+	      macro=AutodiffDependentObjectNamesEnum()
+	"""
+
+	return StringToEnum('AutodiffDependentObjectNames')[0]
+
+def AutodiffDependentObjectTypesEnum():
+	"""
+	AUTODIFFDEPENDENTOBJECTTYPESENUM - Enum of AutodiffDependentObjectTypes
+
+	   Usage:
+	      macro=AutodiffDependentObjectTypesEnum()
+	"""
+
+	return StringToEnum('AutodiffDependentObjectTypes')[0]
+
+def AutodiffDependentObjectsEnum():
+	"""
+	AUTODIFFDEPENDENTOBJECTSENUM - Enum of AutodiffDependentObjects
+
+	   Usage:
+	      macro=AutodiffDependentObjectsEnum()
+	"""
+
+	return StringToEnum('AutodiffDependentObjects')[0]
 
 def AutodiffNumIndependentsEnum():
@@ -59,4 +79,44 @@
 	return StringToEnum('AutodiffNumIndependents')[0]
 
+def AutodiffNumIndependentObjectsEnum():
+	"""
+	AUTODIFFNUMINDEPENDENTOBJECTSENUM - Enum of AutodiffNumIndependentObjects
+
+	   Usage:
+	      macro=AutodiffNumIndependentObjectsEnum()
+	"""
+
+	return StringToEnum('AutodiffNumIndependentObjects')[0]
+
+def AutodiffIndependentObjectNamesEnum():
+	"""
+	AUTODIFFINDEPENDENTOBJECTNAMESENUM - Enum of AutodiffIndependentObjectNames
+
+	   Usage:
+	      macro=AutodiffIndependentObjectNamesEnum()
+	"""
+
+	return StringToEnum('AutodiffIndependentObjectNames')[0]
+
+def AutodiffIndependentObjectTypesEnum():
+	"""
+	AUTODIFFINDEPENDENTOBJECTTYPESENUM - Enum of AutodiffIndependentObjectTypes
+
+	   Usage:
+	      macro=AutodiffIndependentObjectTypesEnum()
+	"""
+
+	return StringToEnum('AutodiffIndependentObjectTypes')[0]
+
+def AutodiffIndependentObjectsEnum():
+	"""
+	AUTODIFFINDEPENDENTOBJECTSENUM - Enum of AutodiffIndependentObjects
+
+	   Usage:
+	      macro=AutodiffIndependentObjectsEnum()
+	"""
+
+	return StringToEnum('AutodiffIndependentObjects')[0]
+
 def AutodiffJacobianEnum():
 	"""
@@ -79,13 +139,23 @@
 	return StringToEnum('AutodiffXp')[0]
 
-def AutodiffFosForwardOutputEnum():
-	"""
-	AUTODIFFFOSFORWARDOUTPUTENUM - Enum of AutodiffFosForwardOutput
-
-	   Usage:
-	      macro=AutodiffFosForwardOutputEnum()
-	"""
-
-	return StringToEnum('AutodiffFosForwardOutput')[0]
+def AutodiffDriverEnum():
+	"""
+	AUTODIFFDRIVERENUM - Enum of AutodiffDriver
+
+	   Usage:
+	      macro=AutodiffDriverEnum()
+	"""
+
+	return StringToEnum('AutodiffDriver')[0]
+
+def AutodiffFosForwardIndexEnum():
+	"""
+	AUTODIFFFOSFORWARDINDEXENUM - Enum of AutodiffFosForwardIndex
+
+	   Usage:
+	      macro=AutodiffFosForwardIndexEnum()
+	"""
+
+	return StringToEnum('AutodiffFosForwardIndex')[0]
 
 def BalancethicknessSpcthicknessEnum():
@@ -199,4 +269,14 @@
 	return StringToEnum('ConstantsYts')[0]
 
+def DependentObjectEnum():
+	"""
+	DEPENDENTOBJECTENUM - Enum of DependentObject
+
+	   Usage:
+	      macro=DependentObjectEnum()
+	"""
+
+	return StringToEnum('DependentObject')[0]
+
 def DiagnosticAbstolEnum():
 	"""
@@ -589,4 +669,14 @@
 	return StringToEnum('HydrologyStabilization')[0]
 
+def IndependentObjectEnum():
+	"""
+	INDEPENDENTOBJECTENUM - Enum of IndependentObject
+
+	   Usage:
+	      macro=IndependentObjectEnum()
+	"""
+
+	return StringToEnum('IndependentObject')[0]
+
 def InversionControlParametersEnum():
 	"""
@@ -2539,4 +2629,14 @@
 	return StringToEnum('DoubleInput')[0]
 
+def DataSetParamEnum():
+	"""
+	DATASETPARAMENUM - Enum of DataSetParam
+
+	   Usage:
+	      macro=DataSetParamEnum()
+	"""
+
+	return StringToEnum('DataSetParam')[0]
+
 def DoubleMatArrayParamEnum():
 	"""
@@ -4757,4 +4857,4 @@
 	"""
 
-	return 474
-
+	return 484
+